# Interface FeedbackListener

public interface FeedbackListener
Receives the outcome of the Codename One drawn rating widget shown by `AppReview` when the platform has no native review prompt (or when the user gave a low rating). Register an implementation via `AppReview.setFeedbackListener(FeedbackListener)` to collect feedback through your own channel (e.g. a support backend) instead of the built in e-mail composer.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `feedback(int rating, String feedback)`
  Invoked with the free text the user typed in the built in feedback composer, when `AppReview` is left to handle the low rating flow and a support e-mail address was configured.
  `boolean`
  `lowRating(int rating)`
  Invoked when the user picked a rating below the configured high rating threshold (see `AppReview.setHighRatingThreshold(int)`) and therefore should be routed to a private feedback flow rather than the public store.

- ## Method Details

  - ### lowRating

    boolean lowRating(int rating)

    Invoked when the user picked a rating below the configured high rating threshold (see `AppReview.setHighRatingThreshold(int)`) and therefore should be routed to a private feedback flow rather than the public store.

    Returning `true` signals that the listener is presenting its own feedback experience, so `AppReview` will not show the built in feedback composer. Returning `false` lets `AppReview` fall back to its default behaviour (e-mail to the configured support address, if any).

    ###### Parameters

    - `rating`: the star value the user selected, from 1 to the rating widget's maximum (5 by default).

    ###### Returns

    true if the listener handled the low rating itself.

  - ### feedback

    void feedback(int rating, String feedback)

    Invoked with the free text the user typed in the built in feedback composer, when `AppReview` is left to handle the low rating flow and a support e-mail address was configured. Implement this to intercept the text and deliver it yourself; it is not called when `lowRating(int)` already returned `true`.

    ###### Parameters

    - `rating`: the star value the user selected.

    - `feedback`: the free text entered by the user, never null but possibly empty.